/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_TOOLBUTTON_H
#define GRAPHIC_TOOLBUTTON_H

#include <InterViews/action.h>
#include <InterViews/telltale.h>
#include <InterViews/monoglyph.h>

class Button;
class Color;
class TelltaleState;
class Tool;

Button *tool_button(Glyph *g,TelltaleFlags f,TelltaleGroup *tg,Action *a);

class PushButtonState: public TelltaleState
{
	public:
		PushButtonState(const TelltaleFlags,Action *);
		virtual void set(const TelltaleFlags, boolean);
	private:
		Action *_action;
};

class ToolAction: public Action
{
	public:
		ToolAction(Tool *);
		virtual ~ToolAction();

		virtual void execute();
	private:
		Tool *_tool;
};

class GraphicGlyph: public MonoGlyph
{
	public:
		GraphicGlyph(Graphic *,const Color *active=nil);
		virtual ~GraphicGlyph();

		virtual void request(Requisition &) const;
		virtual void allocate(Canvas *,const Allocation &,Extension &);
		virtual void draw(Canvas *,const Allocation &) const;
		virtual void undraw();

		void state(TelltaleState *);
		TelltaleState *state() const;
	private:
		TelltaleState *_state;
		const Color *_active;
};

#endif
